/*Express makes it easy to register route handlers for POST requests. Here's a basic POST request handler.*/
const express = require('express');

const app = express();

// Parse JSON bodies for this app. Make sure you put
// `app.use(express.json())` **before** your route handlers!
app.use(express.json());

/*
app.post('/', function requestHandler(req, res) {
    console.log('post() start...');
    res.end('Hello, World!');
    console.log('post() done.');
});
*/

app.post('*', (req, res) => {
    console.log('post() req.body: ' + JSON.stringify(req.body));
    const answerBody = { answer: 42};
    //req.body; // JavaScript object containing the parsed JSON
    //res.json(req.body);
    res.json(answerBody);
});

const server = app.listen(3000, 'localhost', () => {
    const host = server.address().address;
    const port = server.address().port;

    console.log('listen() running at http://%s:%s', host, port);
});
